#include <windows.h>
#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include "../pdf2txt.h"

void ConvertPDFFile2TextFile(char *pdffile, char *textfile)
{
	SetAutoSupportUnicode(FALSE);
	SetPageSeparator("<<<<<<<<<********>>>>>>>>>>>>>");
	SetZoomRatio(100);
	SetAutoAddSpace(FALSE);
	SetTXTFormat(1);
	SetOpenResultFile(1);
	SetDeleteBlankLine(TRUE);
	PDF2TXT(pdffile,textfile);
}
void ConvertPDFFile2TextBuffer(char *pdffile, char *textfile)
{
	SetPageSeparator("<<<<<<<<<********>>>>>>>>>>>>>");
	SetZoomRatio(100);
	SetTXTFormat(1);
	SetOpenResultFile(0);
	SetDeleteBlankLine(TRUE);
	int textBufferSize;
#ifndef UNICODE
	const char *textbuffer = PDF2TextBuffer(pdffile,&textBufferSize);
	if(textbuffer)
		printf("%s\n",textbuffer);
	PDF2TextFreeBuffer(textbuffer);
#else
	WCHAR m_wcharBuf[MAX_PATH];
	memset(m_wcharBuf,0,sizeof(WCHAR)*MAX_PATH);
	MultiByteToWideChar(CP_ACP,0,pdffile,strlen(pdffile),&m_wcharBuf[0],MAX_PATH);
	LPCWSTR textbuffer = PDF2TextBufferW(m_wcharBuf,&textBufferSize);
	PDF2TextFreeBufferW(textbuffer);
#endif
}
void ConvertPDFBuffer2TextBuffer(char *pdffile, char *textfile)
{
	int m_iFileLength = 0;
	char* pdfBuffer = NULL;
  	FILE *file = fopen(pdffile,"rb");
	if(file)
	{
		m_iFileLength = _filelength(fileno(file));
		if(m_iFileLength <= 0)
		{
			fclose(file);
			return;
		}
		pdfBuffer = new char[m_iFileLength];
		if(pdfBuffer == NULL)
		{
			fclose(file);
			return;
		}
		memset(pdfBuffer,0,m_iFileLength);
		fread(pdfBuffer,1,m_iFileLength,file);
		fclose(file);
	}
	if(pdfBuffer == NULL || m_iFileLength <= 0)
		return;

	SetPageSeparator("<<<<<<<<<********>>>>>>>>>>>>>");
	SetZoomRatio(100);
	SetTXTFormat(1);
	SetOpenResultFile(0);
	SetDeleteBlankLine(TRUE);

	int textBufferSize;
	const char *textbuffer = PDFBuffer2TextBuffer(pdfBuffer,m_iFileLength,&textBufferSize);
	if(textbuffer)
		printf("%s\n",textbuffer);
	PDF2TextFreeBuffer(textbuffer);

	delete []pdfBuffer;
}
void main(int argc,char *argv[])
{
	if(argc != 3)
	{
		printf("Usage: input.pdf output.txt");
		return;
	}
	ConvertPDFFile2TextFile(argv[1],argv[2]);
/*	printf("Press any key to continue ...\n");
	getchar();
	ConvertPDFFile2TextBuffer(argv[1],argv[2]);
	printf("Press any key to continue ...\n");
	getchar();
	ConvertPDFBuffer2TextBuffer(argv[1],argv[2]);
	printf("Press any key to continue ...\n");
	getchar();
*/
}